SoLineHighlightRenderAction Class Reference
Action Classes

The SoLineHighlightRenderAction class renders selections with line highlighting. More...

`#include <Inventor/actions/SoLineHighlightRenderAction.h>`

Inheritance diagram for SoLineHighlightRenderAction:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoLineHighlightRenderAction (void)
| SoLineHighlightRenderAction (const SbViewportRegion &viewportregion)
virtual | ~SoLineHighlightRenderAction (void)
virtual void | apply (SoNode *node)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
void | setVisible (const SbBool visible)
SbBool | isVisible (void) const
void | setColor (const SbColor &color)
const SbColor & | getColor (void)
void | setLinePattern (uint16_t pattern)
uint16_t | getLinePattern (void) const
void | setLineWidth (const float width)
float | getLineWidth (void) const
Public Member Functions inherited from SoGLRenderAction
| SoGLRenderAction (const SbViewportRegion &viewportregion)
virtual | ~SoGLRenderAction (void)
void | setViewportRegion (const SbViewportRegion &newregion)
const SbViewportRegion & | getViewportRegion (void) const
void | setUpdateArea (const SbVec2f &origin, const SbVec2f &size)
void | getUpdateArea (SbVec2f &origin, SbVec2f &size) const
void | setAbortCallback (SoGLRenderAbortCB *const func, void *const userdata)
void | getAbortCallback (SoGLRenderAbortCB *&func_out, void *&userdata_out) const
void | setTransparencyType (const TransparencyType type)
TransparencyType | getTransparencyType (void) const
void | setTransparentDelayedObjectRenderType (TransparentDelayedObjectRenderType type)
TransparentDelayedObjectRenderType | getTransparentDelayedObjectRenderType (void) const
void | setSmoothing (const SbBool smooth)
SbBool | isSmoothing (void) const
void | setNumPasses (const int num)
int | getNumPasses (void) const
void | setPassUpdate (const SbBool flag)
SbBool | isPassUpdate (void) const
void | setPassCallback (SoGLRenderPassCB *const func, void *const userdata)
void | setCacheContext (const uint32_t context)
uint32_t | getCacheContext (void) const
void | addDelayedPath (SoPath *path)
SbBool | isRenderingDelayedPaths (void) const
SbBool | handleTransparency (SbBool istransparent=FALSE)
void | setCurPass (const int passnum, const int numpasses)
int | getCurPass (void) const
SbBool | abortNow (void)
void | setRenderingIsRemote (SbBool isremote)
SbBool | getRenderingIsRemote (void) const
virtual void | invalidateState (void)
void | addPreRenderCallback (SoGLPreRenderCB *func, void *userdata)
void | removePreRenderCallback (SoGLPreRenderCB *func, void *userdata)
void | setSortedLayersNumPasses (int num)
int | getSortedLayersNumPasses (void) const
void | setSortedObjectOrderStrategy (const SortedObjectOrderStrategy strategy, SoGLSortedObjectOrderCB *cb=NULL, void *closure=NULL)
void | setDelayedObjDepthWrite (SbBool write)
SbBool | getDelayedObjDepthWrite (void) const
SbBool | isRenderingTranspPaths (void) const
SbBool | isRenderingTranspBackfaces (void) const
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
void | apply (SoAction *beingApplied)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoGLRenderAction
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions

virtual const SoEnabledElementsList & | getEnabledElements (void) const
Protected Member Functions inherited from SoGLRenderAction
virtual void | beginTraversal (SoNode *node)
virtual void | endTraversal (SoNode *node)
Protected Member Functions inherited from SoAction
| SoAction (void)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions

static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoGLRenderAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Protected Attributes

SbBool | hlVisible
Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Additional Inherited Members

Public Types inherited from SoGLRenderAction
enum | TransparencyType { SCREEN_DOOR , ADD , DELAYED_ADD , SORTED_OBJECT_ADD , BLEND , DELAYED_BLEND , SORTED_OBJECT_BLEND , SORTED_OBJECT_SORTED_TRIANGLE_ADD , SORTED_OBJECT_SORTED_TRIANGLE_BLEND , NONE , SORTED_LAYERS_BLEND }
enum | TransparentDelayedObjectRenderType { ONE_PASS , NONSOLID_SEPARATE_BACKFACE_PASS }
enum | AbortCode { CONTINUE , ABORT , PRUNE , DELAY }
enum | SortedObjectOrderStrategy { BBOX_CENTER , BBOX_CLOSEST_CORNER , BBOX_FARTHEST_CORNER , CUSTOM_CALLBACK }
typedef AbortCode | SoGLRenderAbortCB(void *userdata)
Public Types inherited from SoAction
enum | AppliedCode { NODE = 0 , PATH = 1 , PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0 , IN_PATH = 1 , BELOW_PATH = 2 , OFF_PATH = 3 }

## Detailed Description

The SoLineHighlightRenderAction class renders selections with line highlighting.

See the documentation of SoBoxHighlightRenderAction.

The only difference between SoBoxHighlightRenderAction and this action is that this action renders highlights by superposing a wireframe image onto each shape instead of the bounding box when drawing the highlight.

Note: an important limitation for this rendering action is that the superimposition of a wireframe is only guaranteed to work correctly for filled shapes, due to a limitation in OpenGL's glPolygonOffset() functionality. For more information, see the class documentation of the SoPolygonOffset node.

See also
  SoBoxHighlightRenderAction, SoSelection

## Constructor & Destructor Documentation

## SoLineHighlightRenderAction() [1/2]

SoLineHighlightRenderAction::SoLineHighlightRenderAction | ( | void |  | ) |

Default constructor. Note: passes a default SbViewportRegion to the parent constructor.

## SoLineHighlightRenderAction() [2/2]

SoLineHighlightRenderAction::SoLineHighlightRenderAction | ( | const SbViewportRegion & | viewportregion | ) |

Constructor, taking an explicit viewportregion to render.

## ~SoLineHighlightRenderAction()

SoLineHighlightRenderAction::~SoLineHighlightRenderAction | ( | void |  | ) |

virtual

The destructor.

## Member Function Documentation

## getTypeId()

SoType SoLineHighlightRenderAction::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and "downward" casting.

Reimplemented from SoGLRenderAction.

## getClassTypeId()

SoType SoLineHighlightRenderAction::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## addMethod()

void SoLineHighlightRenderAction::addMethod | ( | const SoType | type,
|  | SoActionMethod | method )

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## enableElement()

void SoLineHighlightRenderAction::enableElement | ( | const SoType | type,
|  | const int | stackindex )

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## getEnabledElements()

const SoEnabledElementsList & SoLineHighlightRenderAction::getEnabledElements | ( | void |  | ) | const

protected virtual

Returns list of enabled elements.

Reimplemented from SoGLRenderAction.

## getClassEnabledElements()

SoEnabledElementsList * SoLineHighlightRenderAction::getClassEnabledElements | ( | void |  | ) |

static protected

Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## getClassActionMethods()

SoActionMethodList * SoLineHighlightRenderAction::getClassActionMethods | ( | void |  | ) |

static protected

Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## initClass()

void SoLineHighlightRenderAction::initClass | ( | void |  | ) |

static

Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

## apply() [1/3]

void SoLineHighlightRenderAction::apply | ( | SoNode * | root | ) |

virtual

Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoAction.

## apply() [2/3]

void SoLineHighlightRenderAction::apply | ( | SoPath * | path | ) |

virtual

Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoAction.

## apply() [3/3]

void SoLineHighlightRenderAction::apply | ( | const SoPathList & | pathlist,
|  | SbBool | obeysrules = FALSE )

virtual

Applies action to the graphs defined by pathlist. If obeysrules is set to `TRUE`, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
  SoAction::apply(SoPath * path)

Reimplemented from SoAction.

## setVisible()

void SoLineHighlightRenderAction::setVisible | ( | const SbBool | visible | ) |

Sets if highlight wireframes should be visible when rendering. Defaults to `TRUE`.

## isVisible()

SbBool SoLineHighlightRenderAction::isVisible | ( | void |  | ) | const

Return if selection wireframes should be visible.

## setColor()

void SoLineHighlightRenderAction::setColor | ( | const SbColor & | color | ) |

Sets the color of the wireframes. Defaults to red.

## getColor()

const SbColor & SoLineHighlightRenderAction::getColor | ( | void |  | ) |

Returns color of selection wireframes.

## setLinePattern()

void SoLineHighlightRenderAction::setLinePattern | ( | uint16_t | pattern | ) |

Sets the line pattern used when drawing wireframes. Defaults to `0xffff` (i.e. full, unstippled lines).

## getLinePattern()

uint16_t SoLineHighlightRenderAction::getLinePattern | ( | void |  | ) | const

Returns line pattern used when drawing wireframe.

## setLineWidth()

void SoLineHighlightRenderAction::setLineWidth | ( | const float | width | ) |

Sets the line width used when drawing wireframe. Defaults to 3 (measured in screen pixels).

## getLineWidth()

float SoLineHighlightRenderAction::getLineWidth | ( | void |  | ) | const

Returns the line width used when drawing wireframe.

## Member Data Documentation

## hlVisible

SbBool SoLineHighlightRenderAction::hlVisible

protected

Boolean which decides whether or not the highlights for selected nodes should be visible.

The documentation for this class was generated from the following files:

- SoLineHighlightRenderAction.h
- SoLineHighlightRenderAction.cpp